## How to Verify the Coq Development

The following instructions were tested on an Arch Linux System, though most steps should carry over to a MacOS System as well.

### Preparing the Execution Environment

First of all, you need the latest version of `opam` installed (from your OS package repository). At the time of writing this was `2.0.3`.

Make sure that you are working with an OCaml compiler at version `4.05.0`. Use `opam switch` to list available environments/OCaml compilers on your system. When a suitable switch exists, simply select it with, e.g.,

```
opam switch 4.05.0`
```
Otherwise you first need to create it with the following command.

```
opam switch create 4.05.0
```

Make sure that your opam environment is updated correctly. Simply follow the on-screen instructions after changing to a different switch. This usually requires executing `eval $(opam env)` in the active terminal.

### Install Coq, Autosubst and Proof General
We want to install a specific version of Coq into our opam switch. To do this, execute the following.
```
opam install coq.8.7.1+1
```

Now before we proceed we should verify that we are actually using the correct version of the coq compiler. `which coqc` should yield a location somewhere in your home directory, like `~/.opam/4.05.0/bin/coqc`. If not, you may need to reevaluate your opam environment settings. And if that does not help, check yout `PATH` configuration. it is also good to verify the actual version by running `coqc --version`.

If everything looks ok, we proceed to install Autosubst, version 1. First we clone the source repository and then check out a specific branch, which has compatibility fixes for Coq >= 8.6.
```
git clone https://github.com/uds-psl/autosubst.git <AS-DIR>
cd <AS-DIR>
git checkout coq86-devel
make
make install
```
The install should work without sudo privileges, since we are installing into the opam switch below our home directory, not systemwide. If everything went according to plan you should now have the directory `~/.opam/4.05.0/lib/coq/user-contrib/Autosubst`

Finally, let us also install ProofGeneral, so that we can examine the proof scripts in Emacs. It can be obtained from `https://github.com/ProofGeneral/PG`. The instructions on the PG repository should be self-explanatory and do not require any specific steps. Just remeber to update your `.emacs` according to the included `INSTALL` file.

### Check the Proof Scripts
Our Coq sources come with a preconfigured `Makefile`, so building the whole thing is as simple as calling
```
make
```
in the extracted directory. Any of the `*.v` files can be examined and stepped through in detail with `emacs`, which should initialise ProofGeneral when it starts. Installing the emacs package `company-coq` through MELPA may optionally improve the experience.
